<!DOCTYPE html>

<html lang="en" data-content_root="../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>rules &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css?v=039e1c02" />
    <script src="../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../_static/doctools.js?v=888ff710"></script>
    <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="scripts" href="../scripts.html" />
    <link rel="prev" title="keyphrase_extractor" href="keyphrase_extractor.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="module-helpers.rules">
<span id="rules"></span><h1>rules<a class="headerlink" href="#module-helpers.rules" title="Link to this heading">¶</a></h1>
<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.dcg">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">dcg</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">grammar</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#dcg"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.dcg" title="Link to this definition">¶</a></dt>
<dd><p>Uses ntlk.CFG to perform Definite Clause Grammar analisis on text.</p>
<p>Arguments:</p>
<blockquote>
<div><p>text (str): Input text.
grammar (str): String prolog like grammar definition.</p>
</div></blockquote>
<p>Returns:</p>
<blockquote>
<div><p>nltk.tree.tree.Tree: An nltk tree with tokens at leaves.</p>
</div></blockquote>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.get_epoch_name">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">get_epoch_name</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">epoch_numbers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[]</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#get_epoch_name"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.get_epoch_name" title="Link to this definition">¶</a></dt>
<dd><p>Get epoch information in epoch name representation from geological papers.</p>
<p>Arguments:</p>
<blockquote>
<div><p>text (str): Input string.
epoch_numbers (list): List of tuples, representing numerical epochs. Defaults to empty list.</p>
</div></blockquote>
<p>Returns:</p>
<blockquote>
<div><p>list: List of strings, each beign epoch name.</p>
</div></blockquote>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.get_epochs_number">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">get_epochs_number</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#get_epochs_number"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.get_epochs_number" title="Link to this definition">¶</a></dt>
<dd><p>Get epoch information in numeric representation from geological papers (KA, MA, GA).</p>
<dl class="simple">
<dt>Arguments:</dt><dd><p>text (str): Input string.</p>
</dd>
<dt>Returns:</dt><dd><p>list: List of tuples, each being epoch in format of (‘num’, […, ‘num’], ‘epoch_scale (ka, ma, ga, …)’).</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.get_key_words">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">get_key_words</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#get_key_words"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.get_key_words" title="Link to this definition">¶</a></dt>
<dd><p>Get key words like, volcano, isotop, etc. as a dictionary in form of key_word: True/False.</p>
<dl class="simple">
<dt>Arguments:</dt><dd><p>text (str): Input string.</p>
</dd>
<dt>Returns:</dt><dd><p>dictionary: Dictionary indicating if the key_word is in the text or not, in form of True/False.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.named_entity_bert">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">named_entity_bert</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#named_entity_bert"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.named_entity_bert" title="Link to this definition">¶</a></dt>
<dd><p>Uses fine-tuned bert (balamurugan1603/bert-finetuned-ner) to search got named entities.</p>
<p>Arguments:</p>
<blockquote>
<div><p>text (str): Input text.</p>
</div></blockquote>
<p>Returns:</p>
<blockquote>
<div><p>list: List where each elent is a dictionary, containing entity_group, score, word/entity, start and end of entity in the text.</p>
</div></blockquote>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.named_entity_nltk">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">named_entity_nltk</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#named_entity_nltk"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.named_entity_nltk" title="Link to this definition">¶</a></dt>
<dd><p>Uses nltk ne_chunk to identify entities.</p>
<p>Arguments:</p>
<blockquote>
<div><p>text (str): Input text.</p>
</div></blockquote>
<p>Returns:</p>
<blockquote>
<div><p>nltk.tree.tree.Tree: An nltk tree with tokens at leaves.</p>
</div></blockquote>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="helpers.rules.named_entity_spacy">
<span class="sig-prename descclassname"><span class="pre">helpers.rules.</span></span><span class="sig-name descname"><span class="pre">named_entity_spacy</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">text</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/helpers/rules.html#named_entity_spacy"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#helpers.rules.named_entity_spacy" title="Link to this definition">¶</a></dt>
<dd><p>Uses spaxy en_core_web_sm to identify entities.</p>
<p>Arguments:</p>
<blockquote>
<div><p>text (str): Input text.</p>
</div></blockquote>
<p>Returns:</p>
<blockquote>
<div><p>list: A list, where each item a list, containing the token (part of the text), the token’s entity annotation and the token’s entity type.</p>
</div></blockquote>
</dd></dl>

</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../modules.html">python</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../helpers.html">helpers</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="helper_functions.html">helper_functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="preprocessing.html">preprocessing</a></li>
<li class="toctree-l3"><a class="reference internal" href="text_encoder.html">text_encoder</a></li>
<li class="toctree-l3"><a class="reference internal" href="get_by_doi.html">get_by_doi</a></li>
<li class="toctree-l3"><a class="reference internal" href="keyphrase_extractor.html">keyphrase_extractor</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">rules</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.dcg"><code class="docutils literal notranslate"><span class="pre">dcg()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.get_epoch_name"><code class="docutils literal notranslate"><span class="pre">get_epoch_name()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.get_epochs_number"><code class="docutils literal notranslate"><span class="pre">get_epochs_number()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.get_key_words"><code class="docutils literal notranslate"><span class="pre">get_key_words()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.named_entity_bert"><code class="docutils literal notranslate"><span class="pre">named_entity_bert()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.named_entity_nltk"><code class="docutils literal notranslate"><span class="pre">named_entity_nltk()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#helpers.rules.named_entity_spacy"><code class="docutils literal notranslate"><span class="pre">named_entity_spacy()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../scripts.html">scripts</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
  <li><a href="../modules.html">python</a><ul>
  <li><a href="../helpers.html">helpers</a><ul>
      <li>Previous: <a href="keyphrase_extractor.html" title="previous chapter">keyphrase_extractor</a></li>
      <li>Next: <a href="../scripts.html" title="next chapter">scripts</a></li>
  </ul></li>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
      |
      <a href="../_sources/helpers/rules.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>